export declare const DEFAULT_GRPC_PORT = 50051;
export declare const DEFAULT_REST_PORT = 8080;
export declare const CREATE = "create";
export declare const READ = "read";
export declare const UPDATE = "update";
export declare const DELETE = "delete";
export declare const SEARCH = "search";
export declare const SUBQUERY = "subquery";
export declare const GET = "GET";
export declare const POST = "POST";
export declare const PUT = "PUT";
export declare const PATCH = "PATCH";
export declare const UNDERSCORE_IDS = "_ids";
export declare const UNDERSCORE_BYKEY = "_byKey";
export declare const UNDERSCORE_INNER = "_inner";
export declare const CHILDREN = "children";
export declare const DOT = ".";
export declare const PIPE = "|";
export declare const EMPTY_STRING = "";
export declare const COMMA = ",";
export declare const COLON = ":";
export declare const STRING = "string";
export declare const NUMBER = "number";
export declare const BOOLEAN = "boolean";
export declare const EQUAL = "equal";
export declare const QUOTED_VALUE = "\"value\"";
export declare const FIELDS = "fields";
export declare const ORDERBY = "orderBy";
export declare const PAGE = "page";
export declare const LIMIT = "limit";
export declare const NOTWHERE = "notWhere";
export declare const DESC = "desc";
export declare const ASC = "asc";
export declare const POINT = "point";
export declare const POLYGON = "polygon";
export declare const RANGE = "range";
export declare const NOT_RANGE = "not_range";
export declare const IN = "in";
export declare const NOT_IN = "not_in";
export declare const NULL = "null";
export declare const NOT_NULL = "not_null";
export declare const GEO_BBOX = "geo_bbox";
export declare const GEO_RADIUS = "geo_radius";
export declare const GEO_POLYGON = "geo_polygon";
export declare const JSON = "json";
export declare const JSONB = "jsonb";
export declare const BIT = "bit";
export declare const TINYINT = "tinyint";
export declare const SMALLINT = "smallint";
export declare const MEDIUMINT = "mediumint";
export declare const INT = "int";
export declare const INTEGER = "integer";
export declare const YEAR = "year";
export declare const GEOMETRY = "geometry";
export declare const LINESTRING = "linestring";
export declare const MULTIPOINT = "multipoint";
export declare const MULTILINESTRING = "multilinestring";
export declare const MULTIPOLYGON = "multipolygon";
export declare const GEOMETRYCOLLECTION = "geometrycollection";
export declare const PIPE_SEPERATOR = "|seperator";
export declare const SEPERATOR = "seperator";
export declare const SUPPORTED_OPERATIONS: {
    equal: boolean;
    gt: boolean;
    gte: boolean;
    lt: boolean;
    lte: boolean;
    not: boolean;
    like: boolean;
    null: boolean;
    not_null: boolean;
    in: boolean;
    not_in: boolean;
    range: boolean;
    not_range: boolean;
    geo_bbox: boolean;
    geo_radius: boolean;
    geo_polygon: boolean;
};
export declare const DEFINED_ARG_LENGTHS: {
    range: number;
    not_range: number;
    geo_bbox: number;
    geo_radius: number;
};
export declare const SYMBOL_JSON: unique symbol;
export declare const SYMBOL_GEOQUERY: unique symbol;
export declare const SYMBOL_GEOQUERY_POINT: unique symbol;
export declare const SYMBOL_GEOQUERY_LINE: unique symbol;
export declare const SYMBOL_GEOQUERY_LSEG: unique symbol;
export declare const SYMBOL_GEOQUERY_BOX: unique symbol;
export declare const SYMBOL_GEOQUERY_PATH: unique symbol;
export declare const SYMBOL_GEOQUERY_POLYGON: unique symbol;
export declare const SYMBOL_GEOQUERY_CIRCLE: unique symbol;
export declare const SYMBOLS_GEO_POINT: symbol[];
export declare const SYMBOLS_GEO_LINE: symbol[];
export declare const SYMBOLS_GEO_LSEG: symbol[];
export declare const SYMBOLS_GEO_BOX: symbol[];
export declare const SYMBOLS_GEO_PATH: symbol[];
export declare const SYMBOLS_GEO_POLYGON: symbol[];
export declare const SYMBOLS_GEO_CIRCLE: symbol[];
export declare const SYMBOL_SOFT_DELETE: unique symbol;
export declare const SYMBOL_UNIQUE_KEY_COMPONENT: unique symbol;
export declare const SYMBOL_UPDATE_DISABLED: unique symbol;
export declare const SYMBOL_CREATE_REQUIRED: unique symbol;
export declare const SYMBOL_CREATE_DISABLED: unique symbol;
export declare const FALSEY_STRING_VALUES: string[];
export declare const REQUIRED_FLAG: {
    presence: string;
};
export declare const SEARCH_QUERY_CONTEXT: {
    fields: any;
    seperator: string;
    notWhere: any;
    statementContext: string;
    orderBy: any;
    page: any;
    limit: any;
};
export declare const SEARCH_SUBQUERY_CONTEXT: {
    seperator: string;
    notWhere: any;
    statementContext: string;
};
export declare const SEARCH_QUERY_CONTEXT_DESCRIPTION: {
    fields: string;
    seperator: string;
    notWhere: string;
    statementContext: string;
    orderBy: string;
    page: string;
    limit: string;
    "x-get-count": string;
    "x-get-sql": string;
};
export declare const SRID = 4326;
export declare const DD_BASE = 1113200;
export declare const BASIC_QUERY_OPERATIONS: Map<any, any>;
export declare const CONTEXT_ERRORS = "context_errors";
export declare const VALIDATION_ERROR = "validation_error";
export declare const RESOURCE_RESPONSE = "resource_response";
export declare const RESOURCE_CALL = "resource_call";
export declare const DB_CALL_FAILED = "db_call_failed";
export declare const STARTUP_FAILED = "startup_failed";
export declare const URL_ROOT_SERVICE = "/service";
export declare const DEBUG = "debug";
export declare const SERVICE = "service";
export declare const HEADER_REQUEST_ID = "x-request-id";
export declare const HEADER_GET_SQL = "x-get-sql";
export declare const HEADER_SQL = "x-sql";
export declare const HEADER_GET_COUNT = "x-get-count";
export declare const HEADER_COUNT = "x-count";
export declare const REGEX_CHAR: RegExp;
export declare const REGEX_NON_DIGIT: RegExp;
export declare const DEFAULT_PAGINATION_LIMIT = 250;
export declare const SERVICE_VERSION: string;
export declare const SERVICE_RESOURCE_NOT_FOUND_BODY: {
    message: string;
    checklist: string[];
};
export declare const COMPLEX_RESOLVER_SEPERATOR = "_subquery_";
export declare const NON_RETURNING_SUCCESS_RESPONSE: {
    success: boolean;
};
export declare const NON_RETURNING_FAILURE_RESPONSE: {
    success: boolean;
};
export declare const UNIQUE_RECORD_NOT_FOUND_WITH_KEYS = "Unique Record Not Found with those keys";
export declare const UNSUPPORTED_CHARACTER_IN_DB = "DB resource name or field contains character unsupported in GraphQL SDL (schema definition language). Supported characters are limited to `[0-9a-zA-Z_]` in all three `fieldsOfConcern`. Review each field within the `problemResources` records. Solutions would include updating the DDL to a name that is supported of omitting the resource from this service via a startup config";
export declare const BAD_CONFIG_COMPLEX_RESOURCE = "one of the resources provided for a complexResource does not exist. Make sure both are reflected in the DB as tables, views or materialized views. They must exist at boot so this system can auto generate the appropriate JOI validators -- which drive all of the REST & GraphQL interfaces (and auto documentation)";
export declare const PERMIT_CREATE = 1;
export declare const PERMIT_READ = 2;
export declare const PERMIT_UPDATE = 4;
export declare const PERMIT_DELETE = 8;
export declare const PERMIT_CRUD: number;
export declare const NEW_LINE = "\n        ";
export declare const DEFAULT_MIGRATION_SCRIPT_NAME = "migration_by_sql_dir";
export declare const DEFAULT_MIGRATION_CONTENT: {
    up: any[];
    down: any[];
};
