"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
exports.getDatabaseResources = void 0;
var postgres_1 = require("./postgres");
var sqlite3_1 = require("./sqlite3");
var mysql_1 = require("./mysql");
exports.getDatabaseResources = function (_a) {
    var db = _a.db;
    var migrationTable = db.client.config.migrations.tableName || "";
    if (db.client.config.client === "pg") {
        return postgres_1.dialect({ migrationTable: migrationTable });
    }
    if (db.client.config.client === "sqlite3") {
        return __assign(__assign({}, sqlite3_1.dialect({ migrationTable: migrationTable })), { dbGeometryColumns: undefined });
    }
    if (db.client.config.client.includes("mysql")) {
        return __assign(__assign({}, mysql_1.dialect({ migrationTable: migrationTable })), { dbGeometryColumns: undefined });
    }
    throw new Error("unsupported db engine: postgres, mysql & sqlite3 only");
};
//# sourceMappingURL=index.js.map