"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
exports.__esModule = true;
exports.gqlModule = void 0;
var core_1 = require("@graphql-modules/core");
var graphql_type_json_1 = require("graphql-type-json");
var const_1 = require("../const");
var utils_1 = require("../utils");
var resolvers_1 = require("./resolvers");
var schema_1 = require("./schema");
exports.gqlModule = function (_a) {
    var dbResources = _a.dbResources, Resources = _a.Resources, toSchemaScalar = _a.toSchemaScalar, hardDelete = _a.hardDelete, metadata = _a.metadata, supportsReturn = _a.supportsReturn, permissions = _a.permissions;
    return __awaiter(void 0, void 0, void 0, function () {
        var _b, typeDefsString, typeDefs, serviceResolvers, appResolvers, AppModule;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, schema_1.gqlSchema({
                        dbResources: dbResources,
                        Resources: Resources,
                        toSchemaScalar: toSchemaScalar,
                        metadata: metadata,
                        supportsReturn: supportsReturn,
                        permissions: permissions
                    })];
                case 1:
                    _b = _c.sent(), typeDefsString = _b.typeDefsString, typeDefs = _b.typeDefs;
                    serviceResolvers = Resources
                        // .filter(
                        //   (item: any) => ![...item[1].name].includes(":")
                        // ) // temp -- will remove when integrating complex into GraphQL
                        .reduce(function (_a, _b) {
                        var _c, _d;
                        var Query = _a.Query, Mutation = _a.Mutation;
                        var name = _b[0], resource = _b[1];
                        var allow = utils_1.permitted(permissions);
                        var permit = {
                            create: allow(name, "create"),
                            read: allow(name, "read"),
                            update: allow(name, "update"),
                            "delete": allow(name, "delete"),
                            any: true
                        };
                        permit.any =
                            permit.create || permit.read || permit.update || permit["delete"];
                        var ResourceName = utils_1.transformNameforResolver(name);
                        var resourcesMap = utils_1.genResourcesMap(Resources);
                        var resolver = resolvers_1.makeServiceResolver(resourcesMap)(resource, hardDelete, resource.supportsReturn);
                        var output = {
                            Query: __assign(__assign({}, Query), (_c = {}, _c["Read" + ResourceName] = resolver("read"), _c["Search" + ResourceName] = resolver("search"), _c)),
                            Mutation: __assign(__assign({}, Mutation), (_d = {}, _d["Create" + ResourceName] = resolver("create"), _d["Update" + ResourceName] = resolver("update"), _d["Delete" + ResourceName] = resolver("delete"), _d))
                        };
                        var keys = Object.values(dbResources[utils_1.getFirstIfSeperated(name)]).filter(function (item) { return item.primarykey; });
                        // if resource lacks keys -- delete resolvers for unique records
                        if (!keys.length) {
                            delete output.Query["Read" + ResourceName];
                            delete output.Mutation["Update" + ResourceName];
                            delete output.Mutation["Delete" + ResourceName];
                        }
                        else {
                            if (!permit.read) {
                                delete output.Query["Read" + ResourceName];
                            }
                            if (!permit.update) {
                                delete output.Mutation["Update" + ResourceName];
                            }
                            if (!permit["delete"]) {
                                delete output.Mutation["Delete" + ResourceName];
                            }
                        }
                        if (!permit.create) {
                            delete output.Query["Create" + ResourceName];
                        }
                        if (!permit.read) {
                            delete output.Query["Search" + ResourceName];
                        }
                        return output;
                    }, { Query: {}, Mutation: {} });
                    appResolvers = {
                        JSONB: graphql_type_json_1["default"],
                        Query: {
                            service_healthz: function (obj, args, context, info) {
                                var db_info = metadata.db_info, rest = __rest(metadata, ["db_info"]);
                                return {
                                    serviceVersion: const_1.SERVICE_VERSION,
                                    timestamp: Date.now(),
                                    metadata: rest,
                                    db_info: db_info
                                };
                            }
                        }
                    };
                    AppModule = new core_1.GraphQLModule({
                        typeDefs: typeDefs,
                        resolvers: [appResolvers, serviceResolvers],
                        context: function (_a) {
                            var ctx = _a.ctx;
                            var reqId = ctx.response.header["x-request-id"] || "uuidv4()";
                            return {
                                reqId: reqId
                            };
                        }
                    });
                    return [2 /*return*/, {
                            AppModule: AppModule,
                            typeDefsString: typeDefsString
                        }];
            }
        });
    });
};
//# sourceMappingURL=index.js.map