"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.ignite = void 0;
var cors = require("@koa/cors");
var apollo_server_koa_1 = require("apollo-server-koa");
var bunyan_1 = require("bunyan");
var knexPostgis = require("knex-postgis");
var Koa = require("koa");
var bodyParser = require("koa-bodyparser");
var compress = require("koa-compress");
var HTTP_STATUS = require("http-status");
var const_1 = require("./const");
var credit_1 = require("./credit");
var middleware_1 = require("./middleware");
var setup_1 = require("./setup");
var utils_1 = require("./utils");
var utils_2 = require("./utils");
__createBinding(exports, utils_2, "initPostProcessing");
__createBinding(exports, utils_2, "permit");
__createBinding(exports, utils_2, "genNextMigrationName");
__createBinding(exports, utils_2, "modularMigration");
// currently this is server wide setting. future will be per resource
var ENABLE_HARD_DELETE = process.env.ENABLE_HARD_DELETE
    ? utils_1.castBoolean(process.env.ENABLE_HARD_DELETE)
    : true;
exports.ignite = function (_a) {
    var db = _a.db, metadata = _a.metadata, resourceSearchMiddleware = _a.resourceSearchMiddleware, complexResources = _a.complexResources, systemPermissions = _a.systemPermissions, resourcePermissions = _a.resourcePermissions, paginationLimit = _a.paginationLimit, grpcPort = _a.grpcPort, redactedFields = _a.redactedFields;
    return __awaiter(void 0, void 0, void 0, function () {
        var st, supportsReturn, permissions, logger, pageLimit, _b, appRouter, serviceRouter, AppModule, AppShortName, grpcService, schema, context, apolloServer, App;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    st = knexPostgis(db);
                    supportsReturn = utils_1.supportsReturnOnCreateAndUpdate(db.client.config.client);
                    permissions = {
                        systemPermissions: systemPermissions
                            ? utils_1.extractPermissions({ systemPermissions: systemPermissions }).systemPermissions
                            : const_1.PERMIT_CRUD,
                        resourcePermissions: utils_1.extractPermissions(resourcePermissions || {})
                    };
                    // this is set here as it is used by the router && the openapi doc generator, gRPC and GraphQL
                    metadata.appName = metadata.appShortName || "service-engine-app";
                    metadata.routerPrefix = "/" + metadata.appName;
                    logger = bunyan_1.createLogger({
                        name: metadata.appName,
                        level: 0
                    });
                    pageLimit = paginationLimit
                        ? Number(paginationLimit)
                        : const_1.DEFAULT_PAGINATION_LIMIT;
                    return [4 /*yield*/, setup_1.prepare({
                            db: db,
                            st: st,
                            metadata: metadata,
                            logger: logger,
                            middleware: resourceSearchMiddleware,
                            supportsReturn: supportsReturn,
                            complexResources: complexResources,
                            hardDelete: ENABLE_HARD_DELETE,
                            permissions: permissions,
                            pageLimit: pageLimit,
                            grpcPort: grpcPort || const_1.DEFAULT_GRPC_PORT,
                            redactedFields: redactedFields || {}
                        })];
                case 1:
                    _b = _c.sent(), appRouter = _b.appRouter, serviceRouter = _b.serviceRouter, AppModule = _b.AppModule, AppShortName = _b.AppShortName, grpcService = _b.grpcService;
                    schema = AppModule.schema, context = AppModule.context;
                    apolloServer = new apollo_server_koa_1.ApolloServer({ schema: schema, context: context });
                    App = new Koa()
                        .use(cors())
                        .use(bodyParser({
                        onerror: function (err, ctx) {
                            // want to log the error
                            var message = "body parse error";
                            logger.error({ err: err }, message);
                            ctx.response.status = HTTP_STATUS.UNPROCESSABLE_ENTITY;
                            ctx.response.body = {
                                message: message,
                                error: err
                            };
                            // TODO: figure out why this response isn't stopping the processing of the request
                            ctx["throw"]("body parse error", 422);
                        }
                    }))
                        .use(middleware_1.prepRequestForService(logger))
                        .use(compress())
                        .use(appRouter.routes())
                        .use(appRouter.allowedMethods())
                        .use(serviceRouter.routes())
                        .use(serviceRouter.allowedMethods());
                    apolloServer.applyMiddleware({
                        app: App,
                        path: "/" + metadata.appName + "/graphql/"
                    });
                    // little self promotion for all my effort :+1:
                    logger.info(credit_1.author, "\uD83E\uDD1D Let's do some work together!");
                    return [2 /*return*/, { App: App, logger: logger, apolloServer: apolloServer, AppShortName: AppShortName, grpcService: grpcService }];
            }
        });
    });
};
//# sourceMappingURL=index.js.map