export declare const standardHeaders: {
    "x-request-id": {
        schema: {
            type: string;
        };
        description: string;
    };
    "x-sql": {
        schema: {
            type: string;
        };
        description: string;
    };
};
export declare const searchHeaders: {
    "x-count": {
        schema: {
            type: string;
        };
        description: string;
    };
    "x-request-id": {
        schema: {
            type: string;
        };
        description: string;
    };
    "x-sql": {
        schema: {
            type: string;
        };
        description: string;
    };
};
export declare const fieldsContext: {
    name: string;
    description: any;
    in: string;
    schema: {
        type: string;
    };
};
export declare const keyParams: (fn: any) => (input: {
    field: string;
    type: string;
}[], resource: string) => {
    name: string;
    description: string;
    in: string;
    required: boolean;
    schema: any;
}[];
export declare const ServiceModels: {
    _service_count: {
        type: string;
        properties: {
            count: {
                type: string;
            };
        };
    };
    _search_interfaces: {
        type: string;
        properties: {};
    };
    _debug_resource_response: {
        type: string;
        properties: {
            payload: {
                type: string;
            };
            context: {
                type: string;
            };
            requestId: {
                type: string;
            };
            searchQuery: {
                type: string;
                nullable: boolean;
            };
            hardDelete: {
                type: string;
                nullable: boolean;
            };
            sql: {
                type: string;
            };
        };
    };
};
export declare const pathGenerator: (pathPrefix: any) => (path: any) => string;
export declare const genDatabaseResourceOpenApiDocs: ({ db, st, logger, metadata, debugMode, validators, dbResources, ResourceReports, supportsReturn, permissions, }: {
    db: any;
    st: any;
    logger: any;
    metadata: any;
    debugMode: any;
    validators: any;
    dbResources: any;
    ResourceReports: any;
    supportsReturn: any;
    permissions: any;
}) => Promise<{
    openapi: string;
    info: any;
    servers: any;
    components: {
        schemas: {
            _service_count: {
                type: string;
                properties: {
                    count: {
                        type: string;
                    };
                };
            };
            _search_interfaces: {
                type: string;
                properties: {};
            };
            _debug_resource_response: {
                type: string;
                properties: {
                    payload: {
                        type: string;
                    };
                    context: {
                        type: string;
                    };
                    requestId: {
                        type: string;
                    };
                    searchQuery: {
                        type: string;
                        nullable: boolean;
                    };
                    hardDelete: {
                        type: string;
                        nullable: boolean;
                    };
                    sql: {
                        type: string;
                    };
                };
            };
        };
    };
    paths: any;
}>;
