"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
exports.__esModule = true;
exports.serviceRouters = void 0;
var Router = require("@koa/router");
var cnst = require("../const");
var graphql_1 = require("../graphql");
var utils_1 = require("../utils");
var openapi_1 = require("./openapi");
var views_1 = require("./views");
var j = JSON.stringify; // convience
var operations = new Map();
operations.set(j({ method: "POST", record: false }), "create");
operations.set(j({ method: "GET", record: false }), "search");
operations.set(j({ method: "PUT", record: true }), "update");
operations.set(j({ method: "DELETE", record: true }), "delete");
operations.set(j({ method: "GET", record: true }), "read");
exports.serviceRouters = function (_a) {
    var db = _a.db, st = _a.st, logger = _a.logger, metadata = _a.metadata, validators = _a.validators, dbResources = _a.dbResources, dbResourceRawRows = _a.dbResourceRawRows, Resources = _a.Resources, toSchemaScalar = _a.toSchemaScalar, protoString = _a.protoString, hardDelete = _a.hardDelete, supportsReturn = _a.supportsReturn, permissions = _a.permissions;
    return __awaiter(void 0, void 0, void 0, function () {
        var appRouter, serviceRouter, ResourceReports, resourcesMap, resourcesReports, apiDocs, apiDocsDebug, typeDefsString, resourceView;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    appRouter = new Router();
                    serviceRouter = new Router({
                        prefix: metadata.routerPrefix
                    });
                    ResourceReports = Resources.map(function (_a) {
                        var name = _a[0], resource = _a[1];
                        return [
                            name,
                            resource.report,
                        ];
                    });
                    resourcesMap = utils_1.genResourcesMap(Resources);
                    resourcesReports = Resources.reduce(function (batch, _a) {
                        var _b;
                        var name = _a[0], _Resource = _a[1];
                        return (__assign(__assign({}, batch), (_b = {}, _b[name] = _Resource.report, _b)));
                    }, {});
                    return [4 /*yield*/, openapi_1.genDatabaseResourceOpenApiDocs({
                            db: db,
                            st: st,
                            logger: logger,
                            metadata: metadata,
                            validators: validators,
                            dbResources: dbResources,
                            ResourceReports: ResourceReports,
                            debugMode: false,
                            supportsReturn: supportsReturn,
                            permissions: permissions
                        })];
                case 1:
                    apiDocs = _b.sent();
                    return [4 /*yield*/, openapi_1.genDatabaseResourceOpenApiDocs({
                            db: db,
                            st: st,
                            logger: logger,
                            metadata: metadata,
                            validators: validators,
                            dbResources: dbResources,
                            ResourceReports: ResourceReports,
                            debugMode: true,
                            supportsReturn: supportsReturn,
                            permissions: permissions
                        })];
                case 2:
                    apiDocsDebug = _b.sent();
                    return [4 /*yield*/, graphql_1.gqlModule({
                            dbResources: dbResources,
                            Resources: Resources,
                            toSchemaScalar: toSchemaScalar,
                            hardDelete: hardDelete,
                            metadata: metadata,
                            supportsReturn: supportsReturn,
                            permissions: permissions
                        })];
                case 3:
                    typeDefsString = (_b.sent()).typeDefsString;
                    appRouter.get("/proto", function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            ctx.response.body = protoString;
                            return [2 /*return*/];
                        });
                    }); });
                    appRouter.get("/schema", function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            ctx.response.body = typeDefsString;
                            return [2 /*return*/];
                        });
                    }); });
                    appRouter.get("/healthz", function (ctx) {
                        var db_info = metadata.db_info, rest = __rest(metadata, ["db_info"]);
                        ctx.response.body = {
                            serviceVersion: cnst.SERVICE_VERSION,
                            timestamp: Date.now(),
                            metadata: rest,
                            db_info: db_info
                        };
                    });
                    appRouter.get("/openapi", function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
                        var debug, docs;
                        return __generator(this, function (_a) {
                            debug = ctx.request.query.debug;
                            docs = debug ? apiDocsDebug : apiDocs;
                            ctx.response.body = docs;
                            return [2 /*return*/];
                        });
                    }); });
                    appRouter.get("/db_resources", function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
                        var resource;
                        var _a;
                        return __generator(this, function (_b) {
                            resource = ctx.request.query.resource;
                            ctx.response.body =
                                resource && dbResources[resource]
                                    ? (_a = {}, _a[resource] = dbResources[resource], _a) : dbResources;
                            return [2 /*return*/];
                        });
                    }); });
                    appRouter.get("/db_resources/raw", function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            ctx.response.body = dbResourceRawRows;
                            return [2 /*return*/];
                        });
                    }); });
                    appRouter.get("/resources", function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            ctx.response.body = resourcesReports;
                            return [2 /*return*/];
                        });
                    }); });
                    resourceView = views_1.serviceView({
                        operations: operations,
                        permissions: permissions,
                        resourcesMap: resourcesMap,
                        hardDelete: hardDelete,
                        logger: logger,
                        db: db,
                        supportsReturn: supportsReturn
                    });
                    serviceRouter.get("/:category/:resource", resourceView);
                    serviceRouter.post("/:category/:resource", resourceView);
                    serviceRouter.get("/:category/:resource/record", resourceView);
                    serviceRouter.post("/:category/:resource/record", resourceView);
                    serviceRouter.put("/:category/:resource/record", resourceView);
                    serviceRouter["delete"]("/:category/:resource/record", resourceView);
                    return [2 /*return*/, { appRouter: appRouter, serviceRouter: serviceRouter }];
            }
        });
    });
};
//# sourceMappingURL=routers.js.map